# Copyright (c) 2023, BLUEWALM. All rights reserved. 
# native heuristics

from math import sqrt
from collections import namedtuple


def generate_configs_native(num_embeddings, embedding_dim, precision):
    # compute the size of the configs 
    size = num_embeddings * embedding_dim
    if precision == 'fp16':
        size = size * 2
    elif precision == 'fp32':
        size = size * 4
    # filter the acceptable configs 
    _config = namedtuple('config', 'embedding_type num_embeddings embedding_dim size precision')
    config = _config('native', num_embeddings, embedding_dim, size, precision)
    configs = [config]
    return configs

