# Copyright (c) 2023, BLUEWALM. All rights reserved. 
# utils

import torch
from math import sqrt


def div(m, n):
    return torch.div(m, n, rounding_mode="trunc")


def mod(m, n):
    return m % n


class Accumulate:
    def __init__(self):
        self.data = [0]
    
    def add(self, x):
        last = self.data[-1]
        new = last + x
        self.data.append(new)
    
    def max(self):
        return max(self.data)


class DoNothing:
    def __getattr__(self, name):
        return self
    
    def __call__(self, *args, **kwargs):
        return self
    
    def __getitem__(self, *args, **kwargs):
        return self

